#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

static void destroy(GtkWidget *widget, gpointer data) {
    gtk_main_quit ();
}

static void press_button0(GtkWidget *widget, GtkWidget *entry) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"Warcraft III.exe");
  if ((pid=fork()) == 0) {
    execlp("wine","wine",aouvrir,"--","-opengl",NULL);
  }
}

static void press_button2(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"TutorialOp.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button3(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"TutorialIn.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button4(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"HumanOp.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button5(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"HumanEd.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button6(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"UndeadEd.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button7(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"OrcEd.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void press_button8(GtkWidget *widget, GtkWidget *entry2) {
  pid_t pid;
  char aouvrir[250];
  strcpy(aouvrir,gtk_entry_get_text(GTK_ENTRY(entry2)));
  strcat(aouvrir,"/");
  strcat(aouvrir,"NightElfEd.mpq");
  if ((pid=fork()) == 0) {
    execlp("mplayer","mplayer","-fs",aouvrir,NULL);
  }
}

static void sauvegarde1(GtkWidget *widget, GtkWidget *entry) {

  FILE *fich;
  char aouvrir[250];
  
  strcpy(aouvrir,"/home/");
            
  strcat(aouvrir,getlogin());
  strcat(aouvrir,"/.warcraft3");     
      fich=fopen(aouvrir,"w");
      if (fich) {
      fputs(gtk_entry_get_text(GTK_ENTRY(entry)),fich);
      fclose(fich);
      }
}

static void sauvegarde2(GtkWidget *widget, GtkWidget *entry2) {

  FILE *fich;
  char aouvrir[250];
  
  strcpy(aouvrir,"/home/");
            
  strcat(aouvrir,getlogin());
  strcat(aouvrir,"/.warcraft3mov");     
      fich=fopen(aouvrir,"w");
      if (fich) {
      fputs(gtk_entry_get_text(GTK_ENTRY(entry2)),fich);
      fclose(fich);
      }

}

int main(int argc, char *argv[]) {

    GtkWidget *window;
    GtkWidget *button[11];
    GtkWidget *box;
    GtkWidget *label;
    GtkWidget *label2;
    GtkWidget *label3;
    GtkWidget *entry;
    GtkWidget *entry2;
    int i;
    FILE *fich;
    char installation[250];
    char videos[250];
    char war3sauv[250];
    char war3vid[250];    
  
    strcpy(war3sauv,"/home/");        
    strcat(war3sauv,getlogin());
    strcat(war3sauv,"/.warcraft3"); 
    strcpy(war3vid,"/home/");        
    strcat(war3vid,getlogin());
    strcat(war3vid,"/.warcraft3mov"); 
    gtk_init(&argc, &argv);

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), "Warcraft 3 pour Linux");
    gtk_widget_set_size_request (GTK_WIDGET (window), 400, 480);
    g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(destroy), NULL);

    gtk_container_set_border_width(GTK_CONTAINER (window), 10);

    box = gtk_vbox_new (FALSE, 0);
    gtk_container_add(GTK_CONTAINER(window), box);
    
    button[1] = gtk_button_new_with_label("Lancer Warcraft 3");
    gtk_box_pack_start (GTK_BOX(box), button[1], TRUE, TRUE, 0);
    label = gtk_label_new ("Vidéos :");
    gtk_box_pack_start (GTK_BOX(box), label, TRUE, TRUE, 0);
    button[2] = gtk_button_new_with_label("Introduction jeu");
    gtk_box_pack_start (GTK_BOX(box), button[2], TRUE, TRUE, 0);
    button[3] = gtk_button_new_with_label("Introduction tutoriel");
    gtk_box_pack_start (GTK_BOX(box), button[3], TRUE, TRUE, 0);
    button[4] = gtk_button_new_with_label("Introduction campagne des humains");
    gtk_box_pack_start (GTK_BOX(box), button[4], TRUE, TRUE, 0);
    button[5] = gtk_button_new_with_label("Fin campagne des humains");
    gtk_box_pack_start (GTK_BOX(box), button[5], TRUE, TRUE, 0);
    button[6] = gtk_button_new_with_label("Fin campagne des mort-vivants");
    gtk_box_pack_start (GTK_BOX(box), button[6], TRUE, TRUE, 0);
    button[7] = gtk_button_new_with_label("Fin campagne des Orcs");
    gtk_box_pack_start (GTK_BOX(box), button[7], TRUE, TRUE, 0);
    button[8] = gtk_button_new_with_label("Fin campagne des Elfes de la Nuit");
    gtk_box_pack_start (GTK_BOX(box), button[8], TRUE, TRUE, 0);
    label2 = gtk_label_new ("Répertoire d'installation :");
    gtk_box_pack_start (GTK_BOX(box), label2, TRUE, TRUE, 0);    
    entry = gtk_entry_new();
    gtk_entry_set_max_length (GTK_ENTRY (entry), 200);
    gtk_box_pack_start (GTK_BOX(box), entry, TRUE, TRUE, 0);
    button[9] = gtk_button_new_with_label("Changer");
    gtk_box_pack_start (GTK_BOX(box), button[9], TRUE, TRUE, 0);
    label3 = gtk_label_new ("Répertoire des vidéos :");
    gtk_box_pack_start (GTK_BOX(box), label3, TRUE, TRUE, 0);    
    entry2 = gtk_entry_new();
    gtk_entry_set_max_length (GTK_ENTRY (entry2), 200);
    gtk_box_pack_start (GTK_BOX(box), entry2, TRUE, TRUE, 0);
    button[10] = gtk_button_new_with_label("Changer");
    gtk_box_pack_start (GTK_BOX(box), button[10], TRUE, TRUE, 0);

    fich=fopen(war3sauv,"r");
    if (fich) {
      fgets(installation,255,fich);
      gtk_entry_set_text (GTK_ENTRY (entry), installation);
      fclose(fich);
    } else {
      gtk_entry_set_text (GTK_ENTRY (entry), "/home/warcraft3");
    }
    
        fich=fopen(war3vid,"r");
    if (fich) {
      fgets(videos,255,fich);   
      gtk_entry_set_text (GTK_ENTRY (entry2), videos);
      fclose(fich);
    } else {
      gtk_entry_set_text (GTK_ENTRY (entry2), "/home/warcraft3/Movies");
    }
    
    g_signal_connect (G_OBJECT (button[1]), "clicked", G_CALLBACK (press_button0), (gpointer) entry);
    g_signal_connect (G_OBJECT (button[9]), "clicked", G_CALLBACK (sauvegarde1), (gpointer) entry);
    g_signal_connect (G_OBJECT (button[10]), "clicked", G_CALLBACK (sauvegarde2), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[3]), "clicked", G_CALLBACK (press_button2), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[2]), "clicked", G_CALLBACK (press_button3), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[4]), "clicked", G_CALLBACK (press_button4), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[5]), "clicked", G_CALLBACK (press_button5), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[6]), "clicked", G_CALLBACK (press_button6), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[7]), "clicked", G_CALLBACK (press_button7), (gpointer) entry2);
    g_signal_connect (G_OBJECT (button[8]), "clicked", G_CALLBACK (press_button8), (gpointer) entry2);
       
    for(i=1;i<11;i++) gtk_widget_show(button[i]);
    gtk_widget_show(entry2); 
    gtk_widget_show(label3);
    gtk_widget_show(entry); 
    gtk_widget_show(label2);
    gtk_widget_show(label);
    gtk_widget_show(box);
    gtk_widget_show(window);

    gtk_main();
    
    return 0;
}
